/**
 * 
 */
package edu.uiuc.ncsa.cet.bean.paw;

import java.util.Map;

import edu.uiuc.ncsa.cet.bean.CETBean;

/**
 * Configuration of input widget to show on web UI for a specific
 * {@link PublishedWorkflow}.
 * 
 * @author Luigi Marini <lmarini@ncsa.illinois.edu>
 * 
 */
@SuppressWarnings("serial")
public class InputConfiguration extends CETBean {

    /** Pretty name **/
    private String title;

    /** Long description **/
    private String description;

    /** Id of widget to instantiate in web UI **/
    private String widgetId;

    public enum TYPE {
        INT, FLOAT, ENUMERATION, STRING, DATASET
    }

    /** Input type **/
    private TYPE                          type;

    /** Min allowed for numbers **/
    private String                        min;

    /** Max allowed for numbers **/
    private String                        max;

    /** Default value **/
    private String                        defaultValue;

    /** Whether to show/hide in the GUI **/
    private boolean                       hidden;

    /** Map of value to string to show in widget **/
    private Map<String, String>           enumeration;

    /** Map from input widget parameter to a list of workflow parameters **/
    private Map<String, MarkedParameters> parametersMap;

    public InputConfiguration() {
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getWidgetId() {
        return widgetId;
    }

    public void setWidgetId(String widgetId) {
        this.widgetId = widgetId;
    }

    public Map<String, MarkedParameters> getParametersMap() {
        return parametersMap;
    }

    public void setParametersMap(Map<String, MarkedParameters> parameterIdMap) {
        this.parametersMap = parameterIdMap;
    }

    public String getType() {
        return type.toString();
    }

    public void setType(String type) {
        this.type = TYPE.valueOf(type);
    }

    public String getMin() {
        return min;
    }

    public void setMin(String min) {
        this.min = min;
    }

    public String getMax() {
        return max;
    }

    public void setMax(String max) {
        this.max = max;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public Map<String, String> getEnumeration() {
        return enumeration;
    }

    public void setEnumeration(Map<String, String> enumeration) {
        this.enumeration = enumeration;
    }

    public boolean isHidden() {
        return hidden;
    }

    public boolean getHidden() {
        return hidden;
    }

    public void setHidden(boolean hidden) {
        this.hidden = hidden;
    }

}
